#import "Controller.h"

@implementation Controller

// EBhE
- (BOOL)windowShouldClose:(id)sender
{
    [NSApp terminate:self];
    return YES;
}

// 
- (void)awakeFromNib
{
    NSRect rect;
    
    _count = 0;
    
    [self initArray];
    rect = [_window frame];
    
    _imageView = [[[NSImageView alloc] initWithFrame:
    NSMakeRect(IMAGE_SIZE_X,IMAGE_SIZE_Y,IMAGE_SIZE_WIDTH,IMAGE_SIZE_HEIGHT)] retain];

    [_drawer setContentSize:NSMakeSize(DRAWER_SIZE_X, rect.size.height)];
    [(NSDrawer *)_drawer setContentView:(NSView *)_imageView];
}

// z̏
- (void)initArray
{
    int i;
    for (i=0; i<STOCK_NUM; i++) {
        _posArray[i] = i;
    }
}

// pasteboard server f[^󂯎
- (void)addArray
{
    int i, aPos, rowIndex;

    if (_count >= STOCK_NUM) {
        aPos = _posArray[0];
        for (i=0; i<(STOCK_NUM - 1); i++) {
            _posArray[i] = _posArray[i+1];                 
        } 
        _posArray[STOCK_NUM - 1] = aPos;
        [self releaseBoard:(STOCK_NUM - 1)];
        _count--;
        
        rowIndex = [_tableView selectedRow];
        [_textView setString:@""];
        [_textField setStringValue:@""];
        if ([_drawer state] == NSDrawerOpenState)
            [_drawer close];
    }
    [self addBoard];
    _count++;
//[self printArray];
    [_tableView reloadData];
    [_tableView deselectRow:rowIndex]; 

}

// If[^폜
- (void)deleteArray: (int)index
{
    int i, aPos;

    aPos = _posArray[index];
    
    [self releaseBoard:index];
    for (i=index; i<(STOCK_NUM - 1); i++)
        _posArray[i] = _posArray[i+1];
    _posArray[STOCK_NUM - 1] = aPos;
    _count--;
//    [self printArray];
    [_tableView reloadData];
}

// z̕\
- (void)printArray
{
    int i;
    
    NSLog(@"*******");
    for (i=0; i<STOCK_NUM; i++) {
        if (_count == i)
            NSLog(@"------");
        NSLog(@"[%d]%d", i, _posArray[i]);

    }
}

// pasteboard server ۂɃf[^󂯎ۑ
- (void)addBoard
{
    NSPasteboard *board = [NSPasteboard generalPasteboard];
    int arrayCount = 0;
    int i;
 
    _array[_posArray[_count]] = [[board types] retain];
    arrayCount = [_array[_posArray[_count]] count];

    for (i=0; i<arrayCount; i++) {        
        _type[_posArray[_count]][i] = [[_array[_posArray[_count]] objectAtIndex:i] retain];
        _data[_posArray[_count]][i] = [[board dataForType: _type[_posArray[_count]][i]]						retain];
    }
}

// f[^
- (void)releaseBoard: (int)index
{
    int i;
    int arrayCount = 0;

    arrayCount = [_array[_posArray[index]] count];
    for (i=0; i< arrayCount; i++) {
        [_type[_posArray[index]][i] release];
        [_data[_posArray[index]][i] release];
    }
    [_array[_posArray[index]] release];
}

// f[^XgbN
- (IBAction)StockBoard:(id)sender
{
    [self addArray];
}

// pasteboard server ɃRs[
- (IBAction)CopyBoard:(id)sender
{
    NSPasteboard *board = [NSPasteboard generalPasteboard];
    BOOL flag;
    int ret;
    int i;
    int row;

    row = [_tableView selectedRow];

    if (row == -1)
        return;

    ret = [board declareTypes:_array[_posArray[row]] owner:nil];
 
    for (i=0; i<[_array[_posArray[row]] count]; i++) {
        flag = [board setData:_data[_posArray[row]][i] forType:_type[_posArray[row]][i]];   
    }
}

// XgbNf[^폜
- (IBAction)DeleteBoard:(id)sender
{
    int row;

    row = [_tableView selectedRow];

//    NSLog(@"row = %d", row);
    if (row == -1)
        return;
    
    [self deleteArray: row];
    [_textView setString:@""];
    [_textField setStringValue:@""];

    if ([_drawer state] == NSDrawerOpenState)
        [_drawer close];

}

- (void)dealloc
{
    int i;
    
    for (i=0; i<_count; i++) {
        [self releaseBoard: i];
    }

    [_imageView release];
    [super dealloc];
}

// eLXgɁ@NSString^̃f[^ǉ
- (void)SetText:(NSString *)str
{        
    NSString *CR = @"\n";

    [_textView replaceCharactersInRange:NSMakeRange([[_textView string] length], 0) 	withString:str];

    [_textView replaceCharactersInRange:NSMakeRange([[_textView string] length], 0) 	withString:CR];

    [_textView scrollRangeToVisible:NSMakeRange([[_textView string] length], 0)];
}

// delegate NSTableView
- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(int)rowIndex
{
    int index;
    int arrayCount;
    int i;
    NSString *str;
    NSImage *image;
    BOOL flag;
       
    index = [aTableView selectedRow];

    [_textView setString:@""];
    [_textField setStringValue:@""];
    
//    NSLog(@"%d", rowIndex);
    if (rowIndex == -1)
        return YES;

    flag = NO;
    arrayCount = [_array[_posArray[rowIndex]] count];
    for (i=0; i<arrayCount; i++) {     
        [self SetText: _type[_posArray[rowIndex]][i]];
//        NSLog(@"%@",_type[_posArray[index]][i]);
        // L^IuWFNg񂩔f
        if ([_type[_posArray[rowIndex]][i] isEqualToString:STRING_TYPE] == YES) {
            str = [[[NSString alloc] initWithData:_data[_posArray[rowIndex]][i]
                    encoding:NSShiftJISStringEncoding] autorelease];
            [_textField setStringValue:str];
        }
        // L^IuWFNg摜f
         if ([_type[_posArray[rowIndex]][i] isEqualToString:TIFF_TYPE] == YES) {
            image = [[NSImage alloc] initWithData:_data[_posArray[rowIndex]][i]];
            [_imageView setImage:image];
            flag = YES;
         }

    }
    
    if (flag == NO) {
        [_drawer close];
    } else if ([_drawer state] != NSDrawerOpenState)
        [_drawer open];
    
    return YES;
}

// NSTableDataSource
- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
    return _count;
}

- (id)tableView:(NSTableView *)aTableView
objectValueForTableColumn:(NSTableColumn *)aTableColumn
row:(int)rowIndex
{    
   if (rowIndex >= 0 && rowIndex < _count) {
        if ([[aTableColumn identifier] isEqual:@"Array"])
            return [self readArray: rowIndex];
        else if ([[aTableColumn identifier] isEqual:@"Type"])
            return [self readType: rowIndex];

    }
    return nil;
}

- (id)readArray: (int) rowIndex
{
    NSNumber *num;
    
    if (rowIndex < _count) {
        num = [NSNumber numberWithInt: [_array[_posArray[rowIndex]] count]];
        return num;
    } else
        return nil;

}

- (id)readType: (int) rowIndex
{
    if (rowIndex < _count)
        return _type[_posArray[rowIndex]][0];
    else
        return nil;
}

@end
